package org.lantsovanton.abstraction.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import java.io.File;
import java.io.IOException;

import javax.swing.*;

import org.lantsovanton.abstraction.model.*;
import org.lantsovanton.gameio.*;
import org.lantsovanton.games.*;

public class GameFrame2 extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private GameComponent2 myComponent;
	private IGame myGame; 
	private IPosition myPosition;
	private Intellect myIntellect;
	private boolean myBeautiful = true;
	
	public GameFrame2(){
		super( "Abstract game " );		
		
		try {
			new GameFactory();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.setJMenuBar( createMainMenu() );
		
		this.addWindowListener( new CloseWindowListener() );
		
		File file = new File("startgame.xml");
		if( file.exists() ){
			try{
				IGameReader reader = new XMLGameReader(); 
				reader.setFile( file );
				myGame = reader.loadGame();
				myPosition = reader.loadPosition();
				myBeautiful = reader.loadbeautiful();
				
				myIntellect = myGame.initialIntellect();
				myIntellect.setPlayer(2);
				myIntellect.setGame(myGame);
				myIntellect.setPosition(myPosition);
			}catch( RuntimeException e ){ 
				myGame = GameFactory.newInstace( GameFactory.games[0] );
				myPosition = myGame.initialPosition();
				myIntellect = GameFactory.newInstace( GameFactory.games[0] ).initialIntellect();
				myIntellect.setGame( myGame );
				myIntellect.setPlayer(2);
				myIntellect.setPosition(myPosition);
			}			
		}else{
			myGame = GameFactory.newInstace( GameFactory.games[0] );
			myPosition = myGame.initialPosition();
			myIntellect = GameFactory.newInstace( GameFactory.games[0] ).initialIntellect();
			myIntellect.setGame( myGame );
			myIntellect.setPlayer(2);
			myIntellect.setPosition(myPosition);
		}
		
		
		
		myComponent = new GameComponent2( myIntellect, myGame, myPosition );
		myComponent.setBeautiful( myBeautiful);
		myComponent.setSize( myPosition.getHight() * 60, myPosition.getWidth() * 60 );
		this.getContentPane().add( myComponent );
		this.setSize(700,650);		
		this.setVisible(true);
		
	}
	
	private class CloseWindowListener implements WindowListener{
	

		public void windowOpened(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void windowClosing(WindowEvent arg0) {
			
				File file = new File("startgame.xml");
				IGameWriter writer = new XMLGameWriter();
				writer.setFile( file );
				writer.setGame(myGame);
				writer.setPosition(myPosition);
				writer.setIntellect(myIntellect);
				writer.setBeautiful( myComponent.isBeautiful() );
				writer.save();
				arg0.getComponent().isVisible();
				System.exit(1);		
			
			
		}

		public void windowClosed(WindowEvent arg0) {
			
				File file = new File("startgame.xml");
				IGameWriter writer = new XMLGameWriter();
				writer.setFile( file );
				writer.setGame(myGame);
				writer.setPosition(myPosition);
				writer.setIntellect(myIntellect);
				writer.setBeautiful( myComponent.isBeautiful() );
				writer.save();
				arg0.getComponent().isVisible();
				System.exit(1);		
			
			
		}

		public void windowIconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void windowDeiconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void windowActivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void windowDeactivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		
	}
	
	private JMenuBar createMainMenu(){ 
		JMenuBar mainMenu = new JMenuBar();
		mainMenu.add( createFileMenu() );
		mainMenu.add( createNewMenu() );
		mainMenu.add( createViewMenu() );
		
		return mainMenu;
	}
	
	private JMenu createViewMenu(){
		JMenu viewMenu = new JMenu( "View" );
		viewMenu.add( createBeautiful() );
		viewMenu.add( createSimple() );
		viewMenu.setMnemonic( 'V' );
		return viewMenu;
	}
	
	private JMenuItem createSimple(){
		JMenuItem simple = new JMenuItem("Simple");
		simple.setMnemonic('M');
		simple.addActionListener( new ViewMenuListener(false) );
		return simple;
	}
	
	private JMenuItem createBeautiful(){
		JMenuItem beauty = new JMenuItem("Beautiful");
		beauty.setMnemonic('B');
		beauty.addActionListener( new ViewMenuListener(true) );
		return beauty;		
	}
	
	private JMenu createNewMenu(){
		JMenu newMenu = new JMenu("Game");
		newMenu.setMnemonic('G');
		int s = GameFactory.games.length;
		JMenuItem[] menuItems = new JMenuItem[s];
		for( int i = 0; i < s ; i++ ){
			menuItems[i] = new JMenuItem( GameFactory.games[i] );			
			menuItems[i].addActionListener( new NewGameListener(i) );
			newMenu.add( menuItems[i] );
		}		
		return newMenu;
	}
	
	private JMenu createFileMenu(){ 
		JMenu filemenu = new JMenu("File");
		filemenu.setMnemonic('F');
		filemenu.add( createLoadMenu() );
		filemenu.add( createSaveMenu() );
		filemenu.add( createExitMenu() );
		return filemenu;
	}
	
	private JMenuItem createExitMenu(){
		JMenuItem exitmenu = new JMenuItem("Exit");
		exitmenu.setMnemonic('E');
		exitmenu.addActionListener( new ExitListener() );
		return exitmenu;
	}
	
	private class ExitListener implements ActionListener{

		public void actionPerformed(ActionEvent arg0)  {
			File file = new File("startgame.xml");
			IGameWriter writer = new XMLGameWriter();
			writer.setFile( file );
			writer.setGame(myGame);
			writer.setPosition(myPosition);
			writer.setIntellect(myIntellect);
			writer.save();
			System.exit(1);			
		}
		
	}
	
	private JMenuItem createLoadMenu(){
		JMenuItem loadMenu = new JMenuItem("Open");
		loadMenu.addActionListener( new LoadListener() );
		loadMenu.setMnemonic('O');
		return loadMenu;
	}
	
	private JMenuItem createSaveMenu(){ 
        JMenuItem saveMenu = new JMenuItem("Save");	
        saveMenu.setMnemonic('S');
        saveMenu.addActionListener( new SaveListener() );
		return saveMenu;
	}
	
	private class NewGameListener implements ActionListener{
		private int myGameNumber;
		
		public NewGameListener( int i ){
			myGameNumber = i;
		}

		public void actionPerformed(ActionEvent arg0) {
			myGame = GameFactory.newInstace( GameFactory.games[myGameNumber] );		
			myPosition = myGame.initialPosition();
			myIntellect = GameFactory.newInstace( GameFactory.games[ myGameNumber ] ).initialIntellect();
			
			myIntellect.setGame( myGame );
			myIntellect.setPlayer(2);
			myIntellect.setPosition(myPosition);
			update();
		}
		
	}
	
	private class LoadListener implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			JFrame frameload = new JFrame("load game");
			JFileChooser filechooser = new JFileChooser();
			frameload.getContentPane().add(filechooser);			
			frameload.setVisible(true);
			int returnVal = filechooser.showOpenDialog(frameload);
			if(returnVal == JFileChooser.APPROVE_OPTION){
				File file = filechooser.getSelectedFile();
				try{
					IGameReader reader = new XMLGameReader(); 
					reader.setFile( file );
					myGame = reader.loadGame();
					myPosition = reader.loadPosition();
					myBeautiful = reader.loadbeautiful();
					
					myIntellect = myGame.initialIntellect();
					myIntellect.setPlayer(2);
					myIntellect.setGame(myGame);
					myIntellect.setPosition(myPosition);
					update();
					frameload.setVisible(false);
				}catch(RuntimeException e){
					frameload.setVisible(false);
				}
				
			}else{
				frameload.setVisible( false );
			}
			
			
		}
		
	}
	
	private class SaveListener implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			JFrame framesave = new JFrame("save game");
			JFileChooser filechooser = new JFileChooser();
			filechooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
			framesave.getContentPane().add(filechooser);			
			framesave.setVisible( true );
			int returnVal = filechooser.showOpenDialog(framesave);
			if(returnVal == JFileChooser.APPROVE_OPTION){
				File file = filechooser.getSelectedFile();			
				try{
					IGameWriter writer = new XMLGameWriter();
					writer.setFile( file );
					writer.setGame(myGame);
					writer.setPosition(myPosition);
					writer.setIntellect(myIntellect);
					writer.setBeautiful(myBeautiful);
					writer.save();
					update();
					framesave.setVisible(false);
				}catch(RuntimeException e){
					framesave.setVisible(false);
				}
				
			}else{
				framesave.setVisible( false );
			}
			
			
		}
		
	}
	
	private void update(){
		myComponent.newGame( myIntellect, myGame, myPosition );		
		myComponent.setBeautiful( myBeautiful );
	}
	
	private class ViewMenuListener implements ActionListener{
		
		private boolean myFlag; 
		
		public ViewMenuListener( boolean flag){
			myFlag = flag;
		}

		public void actionPerformed(ActionEvent arg0) {
			myComponent.setBeautiful( myFlag );
			myBeautiful = myFlag;
		}
		
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {		
		new GameFrame2();
	}

}
