/**
 * 
 */
package org.lantsovanton.games.noughtsandcrosses;

import org.lantsovanton.GameException;
import org.lantsovanton.abstraction.model.Factory;
import org.lantsovanton.abstraction.model.IChip;
import org.lantsovanton.abstraction.model.ICoordinate;
import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IMove;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;
import org.lantsovanton.abstraction.model.impl.Move;




/**
 * @author 
 *
 */
public class NoughtsAndCrosses implements IGame {
    private String myName = "NoughtsAndCrosses";
	private Factory myFactory = new Factory();
    
    public  boolean isWinner(IPosition posit, int player) {
		int temp = 0;
		
		for( int i = 0; i < 3; i++ ){
			if( posit.get( i, i ) == null ){
				break;				
			}
			if( posit.get( i, i ).getPlayer() == player  ){
				temp++;
			}
		}
		if( temp == 3 )
			return true;
		
		temp = 0;
		for( int i = 0; i < 3; i++){
			if( posit.get( i, 2 - i ) == null ){
				break;				
			}
			if( posit.get( i, 2 - i ).getPlayer() == player ){
				temp++;
			}
		}
		if( temp == 3 )
			return true;
		
		for( int i = 0; i < 3; i++ ){
			temp = 0;
			int temp1 = 0;
			for( int j = 0; j < 3; j++){
				if( posit.get( i, j ) != null)
				     if( posit.get( i, j ).getPlayer() == player ){
					     temp++;
				     }
				if( posit.get( j, i ) != null )
				    if( posit.get( j, i ).getPlayer() == player ){
					    temp1++;
				    }
				if( temp == 3 || temp1 ==3 ){
					return true;
				}
			}
		}			
		return false;
	}

	public boolean isMovePosible( IPosition posit, IMove m1 ) {
		if( ! ( m1.isSimple() ) ){
			return false;
		}
		Move m = ( Move ) m1;
		if( posit.get( m.y , m.x ) != null || posit.getPlayer() != m.player )
			return false;		
		if( this.isGameFinish(posit) )
			return false;
		return true;
	}
	
/**
 * @throw GameException
 */
	public void doMove(IPosition posit, IMove m1 ) {	
		
		if( ! isMovePosible(  posit,  m1 ) ){
			throw new GameException();					
		}
		if( ! ( m1.isSimple()) ){
			throw new GameException();	
		}
		
		Move m = ( Move )m1;
		IChip fishka = myFactory.initialChip( m.player);
		posit.set( m.y, m.x, fishka);
		int l = 1;
		if( m.player == 1 ){
			l = 2;
		}
		posit.setPlayer(l);	
	}

	public IPosition initialPosition(){
		return myFactory.initialPosition( 3, 3, 1 );
		//1 - number of player;
	}

	public boolean isGameFinish(IPosition posit) {
		if( isWinner( posit, 1 ) || isWinner( posit, 2 ) ){
			return true;
		}
		for( int i = 0; i < 3; i++){
			for( int j = 0; j < 3; j++ ){
				if( posit.get(i,j) == null )
					return false;
			}
		}
		return true;
	}
/**
 * @throws GameException
 */
	public IPosition tryMove(IPosition posit, IMove m) {
		IPosition result = ( IPosition ) posit.clone();
		doMove( result, m );
		return result;
	}

public String getRegulation() {
	// TODO Auto-generated method stub
	return null;
}

public String whyMoveunPossible(IPosition position, IMove move) {
	return null;
}

public IMove getMove(IPosition position, ICoordinate coordinate) {
	IMove move = myFactory.initialSimpleMove( coordinate.getY() ,coordinate.getX(), position.getPlayer() );
	if( this.isMovePosible( position, move ) ){
		return move;
	}
	return null;
}

public String getName() {
	return myName;
}

public Intellect initialIntellect() {
	
	return new Random001();
}


}
