package test.org.lantsovanton;

import org.lantsovanton.abstraction.model.*;
import org.lantsovanton.abstraction.model.impl.*;
import org.lantsovanton.games.attax.Attax;
import org.lantsovanton.movers.AttaxMove;

import junit.framework.TestCase;

public class AttaxTest extends TestCase {
	
	// do move
	// change player
	// get move
	// move possible
	// game finish
	// is win
	
	public void testPosition(){
		IGame game = new Attax();
		IPosition positionreal = game.initialPosition();
		IPosition positionideal = new Position( 8, 8, 1 );
		positionideal.set( 0,0, new Chip(1) );
		positionideal.set( 7,7, new Chip(1) );
		positionideal.set( 0,7, new Chip(2) );
		positionideal.set( 7,0, new Chip(2) );
		assertEquals( positionreal.toString(), positionideal.toString() );
	}
	
	public void testgetname(){
		IGame game = new Attax();
		assertEquals( "Attax", game.getName() );
	}
	
	public void testdomove(){
		IGame game = new Attax();
		IPosition position1 = game.initialPosition();
		AttaxMove move = new AttaxMove(1);
		move.add(0,0);
		move.add(1,1);
		game.doMove(position1,move);
		IPosition positionideal = new Position( 8, 8, 2 );
		positionideal.set( 1,1, new Chip(1) );
		positionideal.set( 0,0, new Chip(1) );
		positionideal.set( 7,7, new Chip(1) );
		positionideal.set( 0,7, new Chip(2) );
		positionideal.set( 7,0, new Chip(2) );
		assertEquals(  positionideal.toString(), position1.toString() );
		
	}
	
	public void testgetmove(){
		
		IGame game = new Attax();
		IPosition position1 = game.initialPosition();
		AttaxMove move = new AttaxMove(1);
		move.add(0,0);
		move.add(1,1);
		game.getMove(position1, new Coordinate(0,0) );
		IMove move2 = game.getMove(position1, new Coordinate(1,1) );
		assertEquals( move2.toString(), move.toString() );
	}
	
	public void testisfinish(){
		// empty position : excepted true
		// position containe chip of only one of player : excepted true
		// 
	}

}
