package test.org.lantsovanton;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;
import org.lantsovanton.gameio.IGameReader;
import org.lantsovanton.gameio.IGameWriter;
import org.lantsovanton.gameio.XMLGameReader;
import org.lantsovanton.gameio.XMLGameWriter;
import org.lantsovanton.games.noughtsandcrosses.NoughtsAndCrosses;
import org.lantsovanton.games.noughtsandcrosses.Random001;
import org.lantsovanton.games.reversi.RandomReversi;
import org.lantsovanton.games.reversi.Reversi;

import junit.framework.TestCase;

public class IoTest extends TestCase {
	
	public void testwriter(){
		//start position for reversi		
		Intellect intellect = new RandomReversi();
		IGame game = new Reversi();
		IPosition position = game.initialPosition();
		File file = new File( "testwriter1.xml" );
		File fileideal = new File( "writerideal1.xml" );
		IGameWriter writer = new XMLGameWriter();
		writer.setFile( file );
		writer.setGame( game );
		writer.setPosition(position);
		writer.setIntellect(intellect);
		writer.save();
	    try {
			Scanner scannerideal = new Scanner(fileideal);
			Scanner scanner = new Scanner(file);
			while( scanner.hasNext() ){
				assertEquals( scannerideal.next(), scanner.next() );
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 	
		//start position for noughtandcrosses
		intellect = new Random001();
		game = new NoughtsAndCrosses();
		position = game.initialPosition();
		file = new File( "testwriter2.xml" );
		fileideal = new File( "writerideal2.xml" );
		writer = new XMLGameWriter();
		writer.setFile( file );
		writer.setGame( game );
		writer.setPosition(position);
		writer.setIntellect(intellect);
		writer.save();
		try {
			Scanner scannerideal = new Scanner(fileideal);
			Scanner scanner = new Scanner(file);
			while( scanner.hasNext() ){
				assertEquals( scannerideal.next(), scanner.next() );
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 	
	}
	
	public void testreader(){ 
		IGameReader reader = new XMLGameReader(); 
		File fileideal = new File( "writerideal1.xml" );
		reader.setFile(fileideal);
		assertEquals( true, reader.loadGame() instanceof Reversi );
		assertEquals( new Reversi().initialPosition().toString(), reader.loadPosition().toString() );
		assertEquals( "RandomReversi", reader.loadIntellect().getName() );
		//
		reader = new XMLGameReader(); 
		fileideal = new File( "writerideal2.xml" );
		reader.setFile(fileideal);
		assertEquals( true, reader.loadGame() instanceof NoughtsAndCrosses );
		assertEquals( new NoughtsAndCrosses().initialPosition().toString(), reader.loadPosition().toString() );
		assertEquals( "Random001", reader.loadIntellect().getName() );
		
	}
	
	public void testioxml(){
		///write
		
		Intellect intellect = new RandomReversi();
		IGame game = new Reversi();
		IPosition position = game.initialPosition();
		File file = new File( "position1.xml" );
		IGameWriter writer = new XMLGameWriter();
		writer.setFile( file );
		writer.setGame( game );
		writer.setPosition(position);
		writer.setIntellect(intellect);
		writer.save();	
		
		///read
		IGameReader reader = new XMLGameReader();
		reader.setFile( file );
		assertEquals( reader.loadGame().getClass(), game.getClass()  );
		assertEquals( reader.loadIntellect().getClass(), intellect.getClass() );
		assertEquals( reader.loadPosition().toString(), position.toString() );
		
	}
	

}
